Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLabHiveServerApplication.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLabHiveServerApplication.cs	(revision 4302)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/HeuristicLabHiveServerApplication.cs	(revision 4305)
@@ -35,51 +35,50 @@
   [Application("Hive Server", "Server application for the distributed hive engine.", false)]
   public class HeuristicLabHiveServerApplication : ApplicationBase {
-    Dictionary<string, Uri> baseAddrDict = new Dictionary<string, Uri>();
+    //private Dictionary<string, Uri> baseAddrDict = new Dictionary<string, Uri>();
+    private IDictionary<string, ServiceHost> serviceHosts = new Dictionary<string, ServiceHost>();
+    ILifecycleManager lifecycleManager = null;
 
     public override void Run() {
-      ILifecycleManager lifecycleManager = null;
-      ServiceHost slaveServiceHost = null;
-      ServiceHost serverConsoleServiceHost = null;
-      ServiceHost clientServiceHost = null;
       try {
-        slaveServiceHost = new ServiceHost(ApplicationManager.Manager.GetTypes(typeof(ISlaveFacade)).First(), GetUri(WcfSettings.SlaveServiceName));
-        slaveServiceHost.Open();
-
-        serverConsoleServiceHost = new ServiceHost(ApplicationManager.Manager.GetTypes(typeof(IServerConsoleFacade)).First(), GetUri(WcfSettings.ServerConsoleServiceName));
-        serverConsoleServiceHost.Open();
-
-        clientServiceHost = new ServiceHost(ApplicationManager.Manager.GetTypes(typeof(IClientFacade)).First(), GetUri(WcfSettings.ClientServiceName));
-        clientServiceHost.Open();
+        CreateAndOpenServiceHost(typeof(ISlaveFacade), WcfSettings.SlaveServiceName);
+        CreateAndOpenServiceHost(typeof(IServerConsoleFacade), WcfSettings.ServerConsoleServiceName);
+        CreateAndOpenServiceHost(typeof(IClientFacade), WcfSettings.ClientServiceName);
 
         lifecycleManager = ServiceLocator.GetLifecycleManager();
         lifecycleManager.Init();
 
-        Form mainForm = new MainForm(baseAddrDict);
+        Form mainForm = new MainForm(GetBaseAddresses());
         Application.Run();
+      } finally {
+        foreach (ServiceHost host in serviceHosts.Values) {
+          if (host.State == CommunicationState.Opened)
+            host.Close();
+        }
+        if (lifecycleManager != null)
+          lifecycleManager.Shutdown();
+      }
+    }
+
+    private ServiceHost CreateAndOpenServiceHost(Type serviceInterfaceType, string serviceName) {
+      try {
+        ServiceHost host = new ServiceHost(ApplicationManager.Manager.GetTypes(serviceInterfaceType).First());
+        host.Open();
+        serviceHosts.Add(serviceName, host);
+        return host;
       }
       catch (AddressAccessDeniedException ex) {
         throw new Exception("Unable to start WCF-Services due to missing rights. Run the following command as administrator: \"netsh http add urlacl url=http://+" + WcfSettings.DefaultPort + "/ user=MYMACHINE\\UserName\". See inner exception for more details.", ex);
       }
-      finally {
-        if (slaveServiceHost != null && slaveServiceHost.State == CommunicationState.Opened)
-          slaveServiceHost.Close();
-        if (serverConsoleServiceHost != null && serverConsoleServiceHost.State == CommunicationState.Opened)
-          serverConsoleServiceHost.Close();
-        if (clientServiceHost != null && clientServiceHost.State == CommunicationState.Opened)
-          clientServiceHost.Close();
-
-        if(lifecycleManager != null)
-          lifecycleManager.Shutdown();
-      }
     }
 
-    private Uri GetUri(string serviceName) {
-      string ipAddress = WcfSettings.GetActiveIP().ToString();
-      string port = WcfSettings.DefaultPort.ToString();
-      Uri uriHttp = new Uri("http://" + ipAddress + ":" + port + "/" + serviceName + "/");
-      baseAddrDict.Add(serviceName, uriHttp);
-      return uriHttp;
+    private IDictionary<string, Uri> GetBaseAddresses() {
+      IDictionary<string, Uri> dict = new Dictionary<string, Uri>();
+      foreach (KeyValuePair<string, ServiceHost> host in serviceHosts) {
+        foreach (var addr in host.Value.BaseAddresses) {
+          dict.Add(host.Key, addr);
+        }
+      }
+      return dict;
     }
-
   }
 }
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/MainForm.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/MainForm.cs	(revision 4302)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Server/3.3/MainForm.cs	(revision 4305)
@@ -11,5 +11,5 @@
 namespace HeuristicLab.Hive.Server {
   public partial class MainForm : Form {
-    public MainForm(Dictionary<string, Uri> addresses) {
+    public MainForm(IDictionary<string, Uri> addresses) {
       InitializeComponent();
 
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/GetJobCompletedEventArgs.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/GetJobCompletedEventArgs.cs	(revision 4302)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/GetJobCompletedEventArgs.cs	(revision 4305)
@@ -21,5 +21,5 @@
 using System;
 
-namespace HeuristicLab.Hive.Slave.Communication.ServerService {
+namespace HeuristicLab.Hive.Slave.Communication.SlaveService {
   public partial class GetJobCompletedEventArgs : System.ComponentModel.AsyncCompletedEventArgs {
 
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/HeuristicLab.Hive.Slave.Communication-3.3.csproj
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/HeuristicLab.Hive.Slave.Communication-3.3.csproj	(revision 4302)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/HeuristicLab.Hive.Slave.Communication-3.3.csproj	(revision 4305)
@@ -112,9 +112,14 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="GetJobCompletedEventArgs.cs" />
-    <Compile Include="Service References\ServerService\Reference.cs">
+    <Compile Include="Service References\SlaveService\Reference.cs">
       <AutoGen>True</AutoGen>
       <DesignTime>True</DesignTime>
       <DependentUpon>Reference.svcmap</DependentUpon>
     </Compile>
+    <Compile Include="Properties\Settings.Designer.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTimeSharedInput>True</DesignTimeSharedInput>
+      <DependentUpon>Settings.settings</DependentUpon>
+    </Compile>
     <Compile Include="WcfService.cs" />
   </ItemGroup>
@@ -124,5 +129,4 @@
     <None Include="Properties\AssemblyInfo.frame" />
     <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.BusinessObjects.JobDto.datasource" />
-    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseHeartBeat.datasource" />
     <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseObjects.Response.datasource" />
     <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseObjects.ResponseCalendar.datasource" />
@@ -130,35 +134,39 @@
     <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseObjects.ResponseResultReceived.datasource" />
     <None Include="Properties\DataSources\HeuristicLab.PluginInfrastructure.CachedHivePluginInfoDto.datasource" />
-    <None Include="Service References\ServerService\SlaveFacade2.wsdl" />
-    <None Include="Service References\ServerService\SlaveService.wsdl" />
-    <None Include="Service References\ServerService\SlaveService.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\ServerService\SlaveService1.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\ServerService\SlaveService2.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\ServerService\SlaveService3.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\ServerService\SlaveService4.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\ServerService\SlaveService5.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\ServerService\SlaveService6.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\ServerService\SlaveService7.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\ServerService\SlaveService8.xsd">
-      <SubType>Designer</SubType>
-    </None>
-    <None Include="Service References\ServerService\SlaveService9.xsd">
-      <SubType>Designer</SubType>
+    <None Include="Service References\SlaveService\SlaveFacade.wsdl" />
+    <None Include="Service References\SlaveService\SlaveService.wsdl" />
+    <None Include="Service References\SlaveService\SlaveService.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveService\SlaveService1.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveService\SlaveService2.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveService\SlaveService3.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveService\SlaveService4.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveService\SlaveService5.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveService\SlaveService6.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveService\SlaveService7.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveService\SlaveService8.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Service References\SlaveService\SlaveService9.xsd">
+      <SubType>Designer</SubType>
+    </None>
+    <None Include="Properties\Settings.settings">
+      <Generator>SettingsSingleFileGenerator</Generator>
+      <LastGenOutput>Settings.Designer.cs</LastGenOutput>
     </None>
   </ItemGroup>
@@ -177,28 +185,20 @@
   </ItemGroup>
   <ItemGroup>
-    <WCFMetadataStorage Include="Service References\ServerService\" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Service References\ServerService\configuration91.svcinfo" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Service References\ServerService\configuration.svcinfo" />
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.Response.datasource" />
-    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseCalendar.datasource" />
-    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseHB.datasource" />
-    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseJob.datasource" />
-    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponsePlugin.datasource" />
-    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseResultReceived.datasource" />
-    <None Include="Properties\DataSources\HeuristicLab.Hive.Contracts.ResponseSerializedJob.datasource" />
-    <None Include="Service References\ServerService\HeuristicLab.PluginInfrastructure.xsd" />
-    <None Include="Service References\ServerService\Reference.svcmap">
+    <WCFMetadataStorage Include="Service References\SlaveService\" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Service References\SlaveService\SlaveService.disco" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Service References\SlaveService\configuration91.svcinfo" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Service References\SlaveService\configuration.svcinfo" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="Service References\SlaveService\Reference.svcmap">
       <Generator>WCF Proxy Generator</Generator>
       <LastGenOutput>Reference.cs</LastGenOutput>
     </None>
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="Service References\ServerService\SlaveService.disco" />
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/Properties/Settings.settings
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/Properties/Settings.settings	(revision 4305)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/Properties/Settings.settings	(revision 4305)
@@ -0,0 +1,12 @@
+﻿<?xml version='1.0' encoding='utf-8'?>
+<SettingsFile xmlns="http://schemas.microsoft.com/VisualStudio/2004/01/settings" CurrentProfile="(Default)" GeneratedClassNamespace="HeuristicLab.Hive.Slave.Communication.Properties" GeneratedClassName="Settings">
+  <Profiles />
+  <Settings>
+    <Setting Name="HiveUsername" Type="System.String" Scope="User">
+      <Value Profile="(Default)">hiveslave</Value>
+    </Setting>
+    <Setting Name="HivePassword" Type="System.String" Scope="User">
+      <Value Profile="(Default)">hiveslave</Value>
+    </Setting>
+  </Settings>
+</SettingsFile>
Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/Service References/SlaveService/Reference.svcmap
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/Service References/SlaveService/Reference.svcmap	(revision 4305)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/Service References/SlaveService/Reference.svcmap	(revision 4305)
@@ -0,0 +1,42 @@
+<?xml version="1.0" encoding="utf-8"?>
+<ReferenceGroup xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" ID="fe6220fd-6424-4b86-8ce6-6cf3e71c9d96" xmlns="urn:schemas-microsoft-com:xml-wcfservicemap">
+  <ClientOptions>
+    <GenerateAsynchronousMethods>true</GenerateAsynchronousMethods>
+    <EnableDataBinding>true</EnableDataBinding>
+    <ExcludedTypes />
+    <ImportXmlTypes>false</ImportXmlTypes>
+    <GenerateInternalTypes>false</GenerateInternalTypes>
+    <GenerateMessageContracts>false</GenerateMessageContracts>
+    <NamespaceMappings />
+    <CollectionMappings />
+    <GenerateSerializableTypes>true</GenerateSerializableTypes>
+    <Serializer>Auto</Serializer>
+    <UseSerializerForFaults>true</UseSerializerForFaults>
+    <ReferenceAllAssemblies>true</ReferenceAllAssemblies>
+    <ReferencedAssemblies />
+    <ReferencedDataContractTypes />
+    <ServiceContractMappings />
+  </ClientOptions>
+  <MetadataSources>
+    <MetadataSource Address="http://localhost:9000/SlaveService" Protocol="http" SourceId="1" />
+  </MetadataSources>
+  <Metadata>
+    <MetadataFile FileName="SlaveService.xsd" MetadataType="Schema" ID="2958ca14-4b99-44a4-87f0-2c447b0e20d5" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd5" />
+    <MetadataFile FileName="SlaveService.disco" MetadataType="Disco" ID="fa30ccfb-2221-422c-b5d0-c98e8f8ee4c4" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?disco" />
+    <MetadataFile FileName="SlaveService1.xsd" MetadataType="Schema" ID="ff58f22f-9158-4cd0-abcb-754cce4f35ec" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd7" />
+    <MetadataFile FileName="SlaveService2.xsd" MetadataType="Schema" ID="cd1031d1-e26a-41e2-ae9a-f13ca89c5ff2" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd1" />
+    <MetadataFile FileName="SlaveFacade.wsdl" MetadataType="Wsdl" ID="b309bbb6-5a49-4529-bde0-aaa4777da64f" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?wsdl" />
+    <MetadataFile FileName="SlaveService3.xsd" MetadataType="Schema" ID="c461449b-de3b-4cbb-9e58-1cb8becedfa7" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd9" />
+    <MetadataFile FileName="SlaveService4.xsd" MetadataType="Schema" ID="6e57914a-9e5b-4c9d-857d-2d1deac32105" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd4" />
+    <MetadataFile FileName="SlaveService5.xsd" MetadataType="Schema" ID="9ba06ad0-a496-4292-b67b-c24e588b8928" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd8" />
+    <MetadataFile FileName="SlaveService6.xsd" MetadataType="Schema" ID="3f5c7b29-fb3f-4af3-a7fa-deebefba48ce" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd6" />
+    <MetadataFile FileName="SlaveService7.xsd" MetadataType="Schema" ID="25348808-3181-4343-bba3-796e0172b1fd" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd0" />
+    <MetadataFile FileName="SlaveService8.xsd" MetadataType="Schema" ID="4c7dfc61-c84a-4378-b121-38f8f8f2a86a" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd3" />
+    <MetadataFile FileName="SlaveService.wsdl" MetadataType="Wsdl" ID="ef494f6e-9864-4628-b3e8-58f471d5d1bd" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?wsdl=wsdl0" />
+    <MetadataFile FileName="SlaveService9.xsd" MetadataType="Schema" ID="c6237b7a-a9fd-42d5-bcc3-bb872bb61485" SourceId="1" SourceUrl="http://localhost:9000/SlaveService?xsd=xsd2" />
+  </Metadata>
+  <Extensions>
+    <ExtensionFile FileName="configuration91.svcinfo" Name="configuration91.svcinfo" />
+    <ExtensionFile FileName="configuration.svcinfo" Name="configuration.svcinfo" />
+  </Extensions>
+</ReferenceGroup>
